
struct pll_limits
{
	kgi_uint		fref;	/* reference frequency		*/
	kgi_ratio	a;	/* generator dependent factor	*/
	kgi_range	fvco;	/* VCO frequency limits		*/
	kgi_range	p;	/* post-VCO divider range	*/
	kgi_range	mul;	/* multiplier value range	*/
	kgi_range	div;	/* divider value range		*/
};

struct pll_state
{
	kgi_uint	f;		/* produced frequency		*/
	kgi_uint	fvco;		/* VCO frequency		*/
	kgi_uint	p;		/* post-VCO divider		*/
	kgi_uint	mul;		/* multiplier value		*/
	kgi_uint	div;		/* divider value 		*/
};


static kgi_uint pll_command(struct pll_state *state, struct kgi_mode *mode);
static void pll_set(struct kgi_display *, kgi_uint);
static kgi_sint pll_best_state(kgi_uint f, enum kgi_tm_cmd cmd,
	struct pll_state *s, const struct pll_limits *pll);
